<?php
namespace App\Models\Organization;
use App\Models\BaseModel;
use App\Libraries\ValueSet;

class WorkstationModel extends BaseModel {
  protected $table = 'workstation';
  protected $primaryKey = 'WorkstationID';
  protected $allowedFields = ['DepartmentID', 'WorkstationCode', 'WorkstationName', 'Type', 'LinkTo', 'isEnable',
    'EquipmentID', 'CreateDate', 'EndDate']; 
		
  protected $useTimestamps = true;
  protected $createdField = 'CreateDate';
  protected $updatedField = '';
  protected $useSoftDeletes = true;
  protected $deletedField = 'EndDate';
   
  public function getWorkstations($filter = []) {
    $this->select('workstation.*, department.DepartmentName, wst1.WorkstationName as LinkToName')
      ->join('workstation wst1', 'workstation.LinkTo=wst1.WorkstationID', 'left')
      ->join('department', 'department.DepartmentID=workstation.DepartmentID', 'left');
       
    if (!empty($filter['WorkstationCode'])) {
      $this->like('workstation.WorkstationCode', $filter['WorkstationCode'], 'both');
    }
    if (!empty($filter['WorkstationName'])) {
      $this->like('workstation.WorkstationName', $filter['WorkstationName'], 'both');
    }
    $rows = $this->findAll();
    return $rows;
  }

  public function getWorkstation($WorkstationID) {
    $row = $this->select("workstation.*, department.DepartmentName, wst1.WorkstationName as LinkToName")
      ->join('workstation wst1', 'workstation.LinkTo=wst1.WorkstationID', 'left')
      ->join('department', 'department.DepartmentID=workstation.DepartmentID', 'left')
      ->where('workstation.WorkstationID', $WorkstationID)
      ->first();
    
    if (!$row) return null;
    
    $row = ValueSet::transformLabels([$row], [
      'Type' => 'ws_type',
      'isEnable' => 'enable_disable',
    ])[0];
    
    return $row;
  }
}
